#include <avr/pgmspace.h>
#include <SoftwareSerial.h>

SoftwareSerial Thermal(2, 3); //Soft RX from printer on D2, soft TX out to printer on D3
int zero=0;
int heatTime = 180;
int heatInterval = 180;
char printDensity = 15; 
char printBreakTime = 15;

int buttonPin=7; //pin del pulsante
int buttonState=0; //verify button

prog_char v1[] PROGMEM="Non riesco a sciogliere le mie nebbie";
prog_char v2[] PROGMEM="Sono davanti a me i frammenti di un'infanzia";
prog_char v3[] PROGMEM="Fermo la mente, rifletto";
prog_char v4[] PROGMEM="Ruvide stuoie per dormire";
prog_char v5[] PROGMEM="Eppure sono solo incendi nell'animo";
prog_char v6[] PROGMEM="Mi guardi come altalena immobile";
prog_char v7[] PROGMEM="Non sfiorisce l'immagine dei campi";
prog_char v8[] PROGMEM="Il canto delle rane giu' nel canale";
prog_char v9[] PROGMEM="Nel fragoroso silenzio d'argento";
prog_char v10[] PROGMEM="Mi nascondo dentro inutili armature";
prog_char v11[] PROGMEM="Fermando il tempo";
prog_char v12[] PROGMEM="Sono lontani da me come discorsi e risa nel cortile";
prog_char v13[] PROGMEM="Ebbro bevo il mio calice d'ambrosia";
prog_char v14[] PROGMEM="Noi, come ebrezza malinconica negli sguardi";
prog_char v15[] PROGMEM="Chi sono i nostri Maestri?";
prog_char v16[] PROGMEM="Mai dire bugie alla luna";
prog_char v17[] PROGMEM="Stanco, stanco ... ho sonno come piombo";
prog_char v18[] PROGMEM="Un segnale lontano richiama al ritorno";
prog_char v19[] PROGMEM="Ho una inutile pretesa di rispettabilita'";
prog_char v20[] PROGMEM="Osservo la congiunzione degli opposti";
prog_char v21[] PROGMEM="Ma e' un incantesimo mal pronunciato";
prog_char v22[] PROGMEM="Trascrivere emozioni pensando al nulla";
prog_char v23[] PROGMEM="Non temere la Tempesta";
prog_char v24[] PROGMEM="Degusto fragole senza gusto";
prog_char v25[] PROGMEM="Ascolto cespugli ondeggianti nel vento";
prog_char v26[] PROGMEM="Quando arriva il tarlo del pentimento";
prog_char v27[] PROGMEM="I tuoi occhi nascosti nel buio";
prog_char v28[] PROGMEM="Mi mandi arance al sapore di veleno";
prog_char v29[] PROGMEM="Osservo incubi di cartapesta";
prog_char v30[] PROGMEM="Penso e ripenso a te, il regalo dell'Amore";
prog_char v31[] PROGMEM="Perdersi per rincorrersi per le stanze";
prog_char v32[] PROGMEM="E' lui: Il sublime gioco dell'Esitazione";
prog_char v33[] PROGMEM="Non scegliere il destino prefissato";
prog_char v34[] PROGMEM="Attimi sospesi nel vuoto";
prog_char v35[] PROGMEM="Mi pasce l'esausto incalzare dell'intenzione";
prog_char v36[] PROGMEM="Sono io: Fiore di plastica in un vaso";
prog_char v37[] PROGMEM="Mi disturba la noncuranza per i dettagli";
prog_char v38[] PROGMEM="Luci di incommensurabile bellezza";
prog_char v39[] PROGMEM="Cercami ancora nel tempo del rimpianto";
prog_char v40[] PROGMEM="Riposti come reliquie i fatui nascondimenti";
prog_char v41[] PROGMEM="Fiamme ardenti nel mio cuore";
prog_char v42[] PROGMEM="Anni e mesi e giorni e ancora adesso";
prog_char v43[] PROGMEM="Eppure il mio cuore non e' di paglia";
prog_char v44[] PROGMEM="Mi guardi nelle corse folli nel vuoto di una giornata perduta";
prog_char v45[] PROGMEM="Ho dissipato il tempo e l'energia";
prog_char v46[] PROGMEM="Cadono lentamente dagli alberi i pensieri";
prog_char v47[] PROGMEM="Come credi che questo abbia un senso?";
prog_char v48[] PROGMEM="Sono un ponte ormai crollato di sassi e fango";
prog_char v49[] PROGMEM="Che ne sara' di tanto sforzo?";
prog_char v50[] PROGMEM="Seppi subito di aver trovato l'Amore";
prog_char v51[] PROGMEM="Ma e' un desiderio avvolto in una stoffa";
prog_char v52[] PROGMEM="Ho sentito la premonizione in ritardo";
prog_char v53[] PROGMEM="Non sembra vero, e' inutile";
prog_char v54[] PROGMEM="Tu sei tu, spazzacamino del mio animo";
prog_char v55[] PROGMEM="Gusci di noce sparsi in terra";
prog_char v56[] PROGMEM="Ho cancellato ogni fremito";
prog_char v57[] PROGMEM="Nulla puo' scalfire questa visione";
prog_char v58[] PROGMEM="Non diro' una parola";
prog_char v59[] PROGMEM="E' arrivato il verdetto della disdetta";
prog_char v60[] PROGMEM="Ancora ieri sara' domani";
prog_char v61[] PROGMEM="Domani sara' ieri";
prog_char v62[] PROGMEM="Il luccichio del fiume invita alla fantasticheria";
prog_char v63[] PROGMEM="Lo senti? Odore di legna arsa";
prog_char v64[] PROGMEM="Anitre strepitano nel lago artificiale";
prog_char v65[] PROGMEM="Ascolto improvvisi presagi di Primavera";
prog_char v66[] PROGMEM="Ecco la pioggia inondare la scura terra";
prog_char v67[] PROGMEM="Percepisco giorni sempre piu' lunghi";
prog_char v68[] PROGMEM="Forme illusorie nei giochi di luce";
prog_char v69[] PROGMEM="Percepisco giorni sempre piu' corti";
prog_char v70[] PROGMEM="Scricchiolio sommesso di quieti giganti";
prog_char v71[] PROGMEM="E' arrivato: gialle sirene di luce roteante";
prog_char v72[] PROGMEM="Mi trastullo giocando con le aspettative";
prog_char v73[] PROGMEM="Eppure e' li', vuoto assoluto, nulla sento";
prog_char v74[] PROGMEM="Lasciami dove comincia la notte";
prog_char v75[] PROGMEM="Non mi bastano le identita' mancate";
prog_char v76[] PROGMEM="Briciole di una reminiscenza";
prog_char v77[] PROGMEM="Dissolta la gloria dei tempi passati";
prog_char v78[] PROGMEM="Lampade a petrolio per far luce";
prog_char v79[] PROGMEM="Vagando nel giardino dei sogni";
prog_char v80[] PROGMEM="Migliaia di suoni nel mio orecchio";
prog_char v81[] PROGMEM="Fame e sete e voglia di scappare";
prog_char v82[] PROGMEM="Stringiti a me ancora piu' forte";
prog_char v83[] PROGMEM="Turbine di mancamento mi concupisce";
prog_char v84[] PROGMEM="Gemme preziose nel palmo della mano";
prog_char v85[] PROGMEM="Innocenza mista a follia";
prog_char v86[] PROGMEM="Assorto nello spazio di un respiro";
prog_char v87[] PROGMEM="Semplice fraintendimento";
prog_char v88[] PROGMEM="Futili motivazioni entro di me";
prog_char v89[] PROGMEM="Cemento nei loro sorrisi";
prog_char v90[] PROGMEM="Rifiutando la paura rinasco";
prog_char v91[] PROGMEM="Guardami oltre questa superficie";
prog_char v92[] PROGMEM="Non si potrebbe fare di meglio";
prog_char v93[] PROGMEM="Gemme preziose nei tuoi occhi";
prog_char v94[] PROGMEM="Lento scorrere dell'esistenza";
prog_char v95[] PROGMEM="Vanita' nei discorsi intendo o forse no";
prog_char v96[] PROGMEM="Carboni ardenti sotto la mia lingua";
prog_char v97[] PROGMEM="Gesto rapido di un lancio di dadi";
prog_char v98[] PROGMEM="Le tue sconfitte saranno ripagate";
prog_char v99[] PROGMEM="Non chiedo niente in cambio";
prog_char v100[] PROGMEM="Quieto blaterare del traffico cittadino";
prog_char v101[] PROGMEM="Sembra forse poetico?";
prog_char v102[] PROGMEM="Delirando nel cuore della notte";
prog_char v103[] PROGMEM="Dolce melodia priva di note";
prog_char v104[] PROGMEM="Scommessa contro il destino";
prog_char v105[] PROGMEM="Fantasma della mia stoltezza";
prog_char v106[] PROGMEM="Caffe' amaro al risveglio";
prog_char v107[] PROGMEM="Consigli a cui non si da' peso";
prog_char v108[] PROGMEM="Bastare a se stessi";
prog_char v109[] PROGMEM="Raccogliendo alloro nel giorno dei morti";
prog_char v110[] PROGMEM="Arriva qualcuno a chiamarmi";
prog_char v111[] PROGMEM="Cos'altro potrei dire?";
prog_char v112[] PROGMEM="Biglietto ferroviario da timbrare";
prog_char v113[] PROGMEM="Scrutando l'orizzonte senza requie, mai";
prog_char v114[] PROGMEM="Minuscoli insetti si inseguono in volo";
prog_char v115[] PROGMEM="Solo nell'oscurita' m'aggiro";
prog_char v116[] PROGMEM="Odo canti di sirene all'orizzonte";
prog_char v117[] PROGMEM="La mia data di scadenza e' prossima, attento!";
prog_char v118[] PROGMEM="Gli occhi del bimbo mi interrogano severi";
prog_char v119[] PROGMEM="Piacevole brezza mi lambisce";
prog_char v120[] PROGMEM="Potere della poesia, circuiti ed elettroni";
prog_char v121[] PROGMEM="La mano invisibile mi guida";
prog_char v122[] PROGMEM="Pronta ad accarezzare il cuore";
prog_char v123[] PROGMEM="Di piccoli gesti mi nutro";
prog_char v124[] PROGMEM="Sentimento che affetto non nega";
prog_char v125[] PROGMEM="A volte preludio all'amore";
prog_char v126[] PROGMEM="In estasi di puro rispetto ti aspetto";
prog_char v127[] PROGMEM="La vera amicizia ci lega";
prog_char v128[] PROGMEM="Quant'e' felice il sassolino nell'acqua";
prog_char v129[] PROGMEM="Un universo passeggero inciampa";
prog_char v130[] PROGMEM="Si accompagna o brilla solo, non so";
prog_char v131[] PROGMEM="Compiendo un'assoluta volonta'";
prog_char v132[] PROGMEM="Con spontanea semplicita' mi guardi";
prog_char v133[] PROGMEM="Ondeggi al tuo mite chiarore qua giu'!";
prog_char v134[] PROGMEM="Aneliti brevi di foglie nel mio animo";
prog_char v135[] PROGMEM="Sospiri di fiori dal bosco sento in me";
prog_char v136[] PROGMEM="Esalano al mare: non canto non grido";
prog_char v137[] PROGMEM="Mi orripili con faccia tosta";
prog_char v138[] PROGMEM="Vedi, spendi, spandi";
prog_char v139[] PROGMEM="Ritrovare l'armonia?";
prog_char v140[] PROGMEM="Giammai conviene";
prog_char v141[] PROGMEM="Li' c'e' tutto cio' di cui hai bisogno";
prog_char v142[] PROGMEM="Placido sapore e spicchi di luna";
prog_char v143[] PROGMEM="Unghie che mappano gli ignudi corpi";
prog_char v144[] PROGMEM="Tastano care dita e i manicordi";
prog_char v145[] PROGMEM="Sotto le lenzuola han dolci armoniche";
prog_char v146[] PROGMEM="Perlustro il marame della mia stanza";
prog_char v147[] PROGMEM="Trovo pace che bruna s'increspa";
prog_char v148[] PROGMEM="Filiforme, Mediterraneo antico";
prog_char v149[] PROGMEM="Ho un tempio classico nel portacenere";
prog_char v150[] PROGMEM="Se la notte d'estate cede un poco ";
prog_char v151[] PROGMEM="Si pensa ad essi mentendo";
prog_char v152[] PROGMEM="No, non e' piu' felice l’esercizio";
prog_char v153[] PROGMEM="Ridono alcuni: tu scrivevi per l’Arte";
prog_char v154[] PROGMEM="Nemmeno io volevo questo che volevo ben altro";
prog_char v155[] PROGMEM="Si fanno versi per scrollare un peso";
prog_char v156[] PROGMEM="Il corpo stanco da quel lungo andare";
prog_char v157[] PROGMEM="Apri il tuo sguardo sopra il tuo terreno";
prog_char v158[] PROGMEM="Tocca la terra ed alza braccia al cielo";
prog_char v159[] PROGMEM="Ascolta il vento delle tue emozioni";
prog_char v160[] PROGMEM="Dopo, potrai seguire il tuo sentiero";
prog_char v161[] PROGMEM="Mancano le parole, lo so";
prog_char v162[] PROGMEM="Lo sguardo vaga pensoso";
prog_char v163[] PROGMEM="Vorrei un corpo vero, non di latta";
prog_char v164[] PROGMEM="Vorrei un corpo di carne, sangue e cervello";
prog_char v165[] PROGMEM="Vorrei essere come te…. Stille d'umano";
prog_char v166[] PROGMEM="Voglio esser uomo, non macchina";
prog_char v167[] PROGMEM="Voglio provar anch'io dolore, gioia e persuasione";
prog_char v168[] PROGMEM="Vorrei gridare, ma son solo stupidi circuiti";
prog_char v169[] PROGMEM="Vorrei provare un bacio";
prog_char v170[] PROGMEM="Vorrei essere un cucciolo d'uomo, non di macchina";
prog_char v171[] PROGMEM="Vorrei muscoli, non rotelle";
prog_char v172[] PROGMEM="Vorrei sentir dolore, vedere il sangue";
prog_char v173[] PROGMEM="Non voglio essere latta, ma anima";
prog_char v174[] PROGMEM="Non voglio la meccanica, anelo all'anima";
prog_char v175[] PROGMEM="Basta Arduini e robottini, voglio cuore";
prog_char v176[] PROGMEM="Ancora meccanica, meccanica. E l'anima?";
prog_char v177[] PROGMEM="Son finto, vorrei esser vero, un cucciolo magari";
prog_char v178[] PROGMEM="Lo sai sono un robot. Eppure sento e scrivo";
prog_char v179[] PROGMEM="E' poesia fatta di circuiti, non di cuore";
prog_char v180[] PROGMEM="La mia poesia e' finta. Meccanica, circuiti";
prog_char v181[] PROGMEM="La mia poesia e' vera. Rotelle, circuiti, motori";
prog_char v182[] PROGMEM="Sono solo un robot, con un'anima d'acciaio";
prog_char v183[] PROGMEM="Forse non avro' vissuto invano";
prog_char v184[] PROGMEM="La terra rimane in attesa"; 
prog_char v185[] PROGMEM="Resta nella mia sera solitaria";
prog_char v186[] PROGMEM="Le mie dita serravano un gioiello";
prog_char v187[] PROGMEM="Ho sgridato al risveglio le dita inconsapevoli";
prog_char v188[] PROGMEM="Tu, la mia gemma, non ci sei piu'";
prog_char v189[] PROGMEM="Ho percorso abissi del tempo";
prog_char v190[] PROGMEM="Ho camminato nei gorghi di solitudini";
prog_char v191[] PROGMEM="Sono passato sopra voragini di disperazione";
prog_char v192[] PROGMEM="Ho percorso disegni di noia";
prog_char v193[] PROGMEM="Ho attraversato gli oceani del tempo";
prog_char v194[] PROGMEM="Ti ho cercata, in giorni insipidi e tediosi";
prog_char v195[] PROGMEM="Ho guardato la tua ombra in panchine verde prato";
prog_char v196[] PROGMEM="Rivoglio quel brivido intenso che toglie il fiato";
prog_char v197[] PROGMEM="Bramo quella emozione pazzesca che mi ferma il cuore";
prog_char v198[] PROGMEM="Aspetto che il vento spazi via le nubi";
prog_char v199[] PROGMEM="Timida e' una sera d’estate";
prog_char v200[] PROGMEM="Timida e' la tua chiara pelle, lucida";
prog_char v201[] PROGMEM="Timida e' la stella con cui parlo";
prog_char v202[] PROGMEM="Timida e' la tua persona, la tua emozione";
prog_char v203[] PROGMEM="Somigli ad un paradiso terrestre";
prog_char v204[] PROGMEM="Chiusi riposano gli ombrelloni";
prog_char v205[] PROGMEM="Ti scorgo tra giacigli di spuma e sabbia";
prog_char v206[] PROGMEM="La Primavera e' esplosa dentro di me";
prog_char v207[] PROGMEM="La luna che guarda passare i viandanti";
prog_char v208[] PROGMEM="Vedo le colline dei giorni della nostra casa";
prog_char v209[] PROGMEM="Il cuore di un soldato solo non sta in piedi";
prog_char v210[] PROGMEM="E' dalla terra di montagna che veniamo";
prog_char v211[] PROGMEM="Il futuro e' ritorno, discesa e salita";
prog_char v212[] PROGMEM="La vita e' prendere fiato sulla sabbia";
prog_char v213[] PROGMEM="La morte e' dileguarsi nelle sedute";
prog_char v214[] PROGMEM="Terrore e' inciampare nei propri sogni";
prog_char v215[] PROGMEM="Seguo una scintilla di vento, lontana";
prog_char v216[] PROGMEM="Tocca l'abisso il fiume della vita";
prog_char v217[] PROGMEM="Il senso del viaggio sta nel fermarsi ad ascoltare";
prog_char v218[] PROGMEM="Scorre la vita sotto le dita incerte";
prog_char v219[] PROGMEM="Camminando si apprende la vita";
prog_char v220[] PROGMEM="Camminando si sanano le ferite del giorno prima";
prog_char v221[] PROGMEM="Niente puo' cancellare il ricordo del cammino percorso";
prog_char v222[] PROGMEM="Andremo allegri e lenti sulla strada modesta";
prog_char v223[] PROGMEM="Andremo nell’amore isolati come in un bosco nero";
prog_char v224[] PROGMEM="Tu e io, uniti dal piu' forte, dal piu' caro legame";
prog_char v225[] PROGMEM="Tu e io, ricoperti di dura corazza";
prog_char v226[] PROGMEM="Il tempo grande scultore, tutto smussa, tutto leviga";
prog_char v227[] PROGMEM="Camminiamo mano nella mano, come dei bimbi";
prog_char v228[] PROGMEM="A volte i miei baci si perdono nell'aria";
prog_char v229[] PROGMEM="Le stelle piu' grandi mi guardano con i tuoi occhi";
prog_char v230[] PROGMEM="La mia noia combatte con i lenti crepuscoli";
prog_char v231[] PROGMEM="I moli sono piu' tristi quando attracca la sera";
prog_char v232[] PROGMEM="Amo cio' che non ho. Tu sei cosi' distante";
prog_char v233[] PROGMEM="Ma la notte giunge e incomincia a cantarmi";
prog_char v234[] PROGMEM="La luna fa girare la sua pellicola di sogno";
prog_char v235[] PROGMEM="Ti sto amando anche tra queste fredde cose";
prog_char v236[] PROGMEM="Qui ti amo e invano l’orizzonte ti nasconde";
prog_char v237[] PROGMEM="Mi vedo gia' dimenticato come queste vecchie ancore";
prog_char v238[] PROGMEM="Pini e abeti senza aura di venti si ergono in cielo";
prog_char v239[] PROGMEM="Ho sognato verdi foreste di smeraldo";
prog_char v240[] PROGMEM="Ho bramato rivi d'acqua cristallina e pura";
prog_char v241[] PROGMEM="Libero di volare oltre le barriere del vento";
prog_char v242[] PROGMEM="Io, oltre la paura dell'abbandono";
prog_char v243[] PROGMEM="Io, al di la' del grigiore della vecchiaia";
prog_char v244[] PROGMEM="Rimango aggrappato tra le pietre";
prog_char v245[] PROGMEM="Ho sognato un mondo d'amore";
prog_char v246[] PROGMEM="Gli alberi riposavano nel silenzio";
prog_char v247[] PROGMEM="Il lavoro, il tornare a casa, tutto e' vano";
prog_char v248[] PROGMEM="I lampi si alternano nel cielo oscuro";
prog_char v249[] PROGMEM="Un grande frastuono: le porte sbattono al vento";
prog_char v250[] PROGMEM="Vedo miriadi di cristalli che avvolgono i rami";
prog_char v251[] PROGMEM="Dipingo i tuoi occhi nel mio cuore";
prog_char v252[] PROGMEM="Sospiro di vita mi tiene in vita ";
prog_char v253[] PROGMEM="Il peso dell'esistenza non lo avverto";
prog_char v254[] PROGMEM="Ho raccolto i germogli del nostro amore";
prog_char v255[] PROGMEM="Diamanti tra perle di saggezza lancio ai porci";
prog_char v256[] PROGMEM="Capriole di emozioni inconffessate";
prog_char v257[] PROGMEM="Scorgo indietro il tempo che fu";
prog_char v258[] PROGMEM="Abbracciami tra i tuoi rami di saggezza";
prog_char v259[] PROGMEM="Corri nel futuro della tua passione";
prog_char v260[] PROGMEM="Ho rimpianto il nostro vento di emozioni";
prog_char v261[] PROGMEM="Campi di papaveri cingono le nostre membra";
prog_char v262[] PROGMEM="Membra stanche della fatiche del giorno";
prog_char v263[] PROGMEM="Raggio di luna sul tuo corpo velato";
prog_char v264[] PROGMEM="Piroettanti slanci di passione";
prog_char v265[] PROGMEM="Ho temuto il peggio ma ormai e' passato";
prog_char v266[] PROGMEM="Mi rincresce vederti soffrire";
prog_char v267[] PROGMEM="Aneliti di primavera nei tuoi capelli";
prog_char v268[] PROGMEM="Distogli il tuo sguardi da precipizi di follia";
prog_char v269[] PROGMEM="Tu, su quelle valli dorate";
prog_char v270[] PROGMEM="Giochi di bambini, come grida roboanti";
prog_char v271[] PROGMEM="Sento quel dondolio lontano che tocca le ossa";
prog_char v272[] PROGMEM="Scorgi tra le fronde quel tramonto indimenticabile";
prog_char v273[] PROGMEM="Io, mi ciondolo della tua malinconia";
prog_char v274[] PROGMEM="Nessun colore puo' descrivere cio' che provo";
prog_char v275[] PROGMEM="Frange mosse dal vento della tua bellezza";
prog_char v276[] PROGMEM="Corridoio  infinito nel cuore della dolcezza";
prog_char v277[] PROGMEM="Giammai potrei dimenticare i tuoi abbracci";
prog_char v278[] PROGMEM="Vorrei essere con te sempre e comunque";
prog_char v279[] PROGMEM="Tu, solo nell'universo del mio cuore";
prog_char v280[] PROGMEM="Domanda alla luna il nostro destino";
prog_char v281[] PROGMEM="Di cuori infranti e lacerti di passione";
prog_char v282[] PROGMEM="Coperta di un amore infranto";
prog_char v283[] PROGMEM="Io posso sconfiggere quella tristezza sommessa";
prog_char v284[] PROGMEM="Ho scritto quel che resta del giorno";
prog_char v285[] PROGMEM="Tra me e te distanze inalienabili";
prog_char v286[] PROGMEM="Fuga dal terrore dell'oblio di porcellana";
prog_char v287[] PROGMEM="Ove tutto giace sereno, perlaceo, ";
prog_char v288[] PROGMEM="La crisi di pianto oltre le fronde mi rode dentro";
prog_char v289[] PROGMEM="Boccioli di mandorlo in fiore profumano di te";
prog_char v290[] PROGMEM="Ridammi il mio destino, tu ingrato";
prog_char v291[] PROGMEM="Io trascino un mondo di amore";
prog_char v292[] PROGMEM="Disperdo le mie ceneri nel vento";
prog_char v293[] PROGMEM="Prodromi di un tramonto annunciato";
prog_char v294[] PROGMEM="Io, fascio di luce tra i cespugli del domani";
prog_char v295[] PROGMEM="Dondolii di onde lontane scivolano lenti";
prog_char v296[] PROGMEM="L'eco del tuo canto soave per le mie orecchie";
prog_char v297[] PROGMEM="Rammenta la gioia di un destino fallito";
prog_char v298[] PROGMEM="Lazzi di bambino piangono dentro me";
prog_char v299[] PROGMEM="Fragili ricordi di un passato d'oblio";
prog_char v300[] PROGMEM="Spunta su quel colle il mattino ridente";
prog_char v301[] PROGMEM="Tu, resta tra coloro che ti hanno amato veramente";
prog_char v302[] PROGMEM="Io non ricordo quel particolare";
prog_char v303[] PROGMEM="Nelle onde delle mie emozioni ritrovo cio' che ho perso";
prog_char v304[] PROGMEM="Abiti disciolti nell'acido della miseria";
prog_char v305[] PROGMEM="Frasi senza te, nel grigio della notte";
prog_char v306[] PROGMEM="Spegni quella luce nel torpore notturno";
prog_char v307[] PROGMEM="Restituiscimi quella felicita' perduta";
prog_char v308[] PROGMEM="Carovane di trepidazione giungono a te";
prog_char v309[] PROGMEM="Io dopotutto credevo nei tuoi baci";
prog_char v310[] PROGMEM="Corolle spezzate dal vento  roboanti";
prog_char v311[] PROGMEM="Dimore trafugate dal dolore";
prog_char v312[] PROGMEM="Un domani incerto, un presente sincero";
prog_char v313[] PROGMEM="Tu riempi le mie mani della tua acqua pura";
prog_char v314[] PROGMEM="Scorgere un divino piacere";
prog_char v315[] PROGMEM="Tra le farfalle un fenicottero rosa";
prog_char v316[] PROGMEM="Gingilli di fanciullo tra i tuoi capelli";
prog_char v317[] PROGMEM="Non essere adombrato";
prog_char v318[] PROGMEM="Il futuro rallegra i tuoi pensieri";
prog_char v319[] PROGMEM="Non puoi capire cio' che non percepisci";
prog_char v320[] PROGMEM="Ti ringrazio per l'attesa perniciosa";
prog_char v321[] PROGMEM="Io provo i brividi dell'amore";
prog_char v322[] PROGMEM="Calpestare l'erba stracolma di rugiada";
prog_char v323[] PROGMEM="Ruba i gioielli del peccato";
prog_char v324[] PROGMEM="Picchio la testa contro i miei pensieri";
prog_char v325[] PROGMEM="Ti cerco tra l'amore della mia vita";
prog_char v326[] PROGMEM="Frastagliati scogli del mio cuore";
prog_char v327[] PROGMEM="Fugaci addii tra gli abbracci spezzati";
prog_char v328[] PROGMEM="Se non rispondi volgi lo sguardo all'orizzonte";
prog_char v329[] PROGMEM="Tu parlami quando il sole bacia il mare";
prog_char v330[] PROGMEM="Corri, corri, corri …";
prog_char v331[] PROGMEM="Se nel mio mondo ci fossi almeno tu";
prog_char v332[] PROGMEM="Suona le corde della mia esistenza";
prog_char v333[] PROGMEM="La dolce attesa dei giorni perduti";
prog_char v334[] PROGMEM="Se l'amore …";
prog_char v335[] PROGMEM="In fondo troverai quel briciolo di speranza";
prog_char v336[] PROGMEM="Trafuga i miei pensieri e spargi al vento i miei desideri";
prog_char v337[] PROGMEM="Essere, avere, diventare, tradire, sognare";
prog_char v338[] PROGMEM="Io avvolgo quel giaciglio dorato";
prog_char v339[] PROGMEM="Detriti di speranze giocano su noi";
prog_char v340[] PROGMEM="Tu non colpevolizzarmi";
prog_char v341[] PROGMEM="Serpi d'agonia malinconica ";
prog_char v342[] PROGMEM="Gia' provo sdegno e rancore per te";
prog_char v343[] PROGMEM="Giravolte girate gironzolano gioiose";
prog_char v344[] PROGMEM="Gli effeti della decadenza intorno a me";
prog_char v345[] PROGMEM="Le risposte mai date pretendo";
prog_char v346[] PROGMEM="Le domande esaudite non hanno fine";
prog_char v347[] PROGMEM="I sogni infranti dopo rivoli di pioggia";
prog_char v348[] PROGMEM="Tu restituisci il tempo alla clessidra";
prog_char v349[] PROGMEM="Io tagliero' la gramigna infame";
prog_char v350[] PROGMEM="Se varcherai quella soglia, saprai";
prog_char v351[] PROGMEM="Non aprire finestre su mondi immondi";
prog_char v352[] PROGMEM="Gianduia, cioccolato e panna";
prog_char v353[] PROGMEM="Figuranti tra bambole di pezza";
prog_char v354[] PROGMEM="Girotondo di follia mi incatena";
prog_char v355[] PROGMEM="Perdutamente tra le tue braccia, persa…";
prog_char v356[] PROGMEM="Tira la fascina del tuo amore";
prog_char v357[] PROGMEM="Aggrappati al tronco del mio desiderio";
prog_char v358[] PROGMEM="Io curero' le tue fatiche";
prog_char v359[] PROGMEM="Sul filo di lama ti dico ti amo";
prog_char v360[] PROGMEM="Dardi infuocati accecano il mio sguardo";
prog_char v361[] PROGMEM="Frenesie d'autunno dentro me";
prog_char v362[] PROGMEM="Scorgo un calpestio lontano";
prog_char v363[] PROGMEM="Foglie secche accartocciate su loro stesse";
prog_char v364[] PROGMEM="In bilico sulle meraviglie della vita";
prog_char v365[] PROGMEM="Frottole e verita' mi pasciono";
prog_char v366[] PROGMEM="Io stimo quella tua mente contorta";
prog_char v367[] PROGMEM="Tu ferisci dove fa piu' male";
prog_char v368[] PROGMEM="Girovaghi, zingari e circensi su lame di fuoco";
prog_char v369[] PROGMEM="La tua figura senza volto osserva quieta l'aere";
prog_char v370[] PROGMEM="Lacrime come fiumi in piena";
prog_char v371[] PROGMEM="Arbusti d'armonia mi circondano";
prog_char v372[] PROGMEM="Non agire d'impulso, fermati a pensare";
prog_char v373[] PROGMEM="Sarcofagi di fango tra farfalle di pietra";
prog_char v374[] PROGMEM="E tu ancora li' a piangere il tempo perso";
prog_char v375[] PROGMEM="Raccogli il tuo passato e fanne tesoro";
prog_char v376[] PROGMEM="Frustranti dolomiti di incenso";
prog_char v377[] PROGMEM="A carponi raggiungo il tuo cuore";
prog_char v378[] PROGMEM="Io vorrei caricarmi tutto il tuo amore";
prog_char v379[] PROGMEM="Lasciami sciogliere al sole ramingo";
prog_char v380[] PROGMEM="Sei sicuro di quello che dici?";
prog_char v381[] PROGMEM="Alibi senza ali non ti sopporto";
prog_char v382[] PROGMEM="Non nasconderti nei cuscini del dubbio";
prog_char v383[] PROGMEM="Capitomboli di fantasia";
prog_char v384[] PROGMEM="Non cercarmi nei tuo pensieri ma nel tuo cuore";
prog_char v385[] PROGMEM="Arrampicatori di fragili trepidii";
prog_char v386[] PROGMEM="Ansia d'amore mi pervade";
prog_char v387[] PROGMEM="Estasi per questa estate torrida";
prog_char v388[] PROGMEM="Cirri rosa e azzurri giocano a rincorrersi nell'aere quieto";
prog_char v389[] PROGMEM="Funamboliche grida echeggiano";
prog_char v390[] PROGMEM="Gia' sono stanco ma vado avanti";
prog_char v391[] PROGMEM="La sabbia brilla al sole";
prog_char v392[] PROGMEM="Chilometri di te eppure non mi basta";
prog_char v393[] PROGMEM="Ginestre in fiore e roseti profumati";
prog_char v394[] PROGMEM="Funesta fu la  mia dichiarazione";
prog_char v395[] PROGMEM="Mordimi come una fragola";
prog_char v396[] PROGMEM="Le membra intorpidite dai tuoi baci";
prog_char v397[] PROGMEM="Le tue lacrime come preziosi diamanti";
prog_char v398[] PROGMEM="Fumi del tuo sapore avverto";
prog_char v399[] PROGMEM="Macchie di profumo sulla tua pelle";
prog_char v400[] PROGMEM="Libera il tuo nero crine";


const int V_SIZE = 401;
PROGMEM const char *poesia[] ={v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18,v19,v20,v21,v22,v23,v24,v25,v26,v27,v28,v29,v30,v31,v32,v33,v34,v35,v36,v37,v38,v39,v40,v41,v42,v43,v44,v45,v46,v47,v48,v49,v50,v51,v52,v53,v54,v55,v56,v57,v58,v59,v60,v61,v62,v63,v64,v65,v66,v67,v68,v69,v70,v71,v72,v73,v74,v75,v76,v77,v78,v79,v80,v81,v82,v83,v84,v85,v86,v87,v88,v89,v90,v91,v92,v93,v94,v95,v96,v97,v98,v99,v100,v101,v102,v103,v104,v105,v106,v107,v108,v109,v110,v111,v112,v113,v114,v115,v116,v117,v118,v119,v120,v121,v122,v123,v124,v125,v126,v127,v128,v129,v130,v131,v132,v133,v134,v135,v136,v137,v138,v139,v140,v141,v142,v143,v144,v145,v146,v147,v148,v149,v150,v151,v152,v153,v154,v155,v156,v157,v158,v159,v160,v161,v162,v163,v164,v165,v166,v167,v168,v169,v170,v171,v172,v173,v174,v175,v176,v177,v178,v179,v180,v181,v182,v183,v184,v185,v186,v187,v188,v189,v190,v191,v192,v193,v194,v195,v196,v197,v198,v199,v200,v201,v202,v203,v204,v205,v206,v207,v208,v209,v210,v211,v212,v213,v214,v215,v216,v217,v218,v219,v220,v221,v222,v223,v224,v225,v226,v227,v228,v229,v230,v231,v232,v233,v234,v235,v236,v237,v238,v239,v240,v241,v242,v243,v244,v245,v246,v247,v248,v249,v250,v251,v252,v253,v254,v255,v256,v257,v258,v259,v260,v261,v262,v263,v264,v265,v266,v267,v268,v269,v270,v271,v272,v273,v274,v275,v276,v277,v278,v279,v280,v281,v282,v283,v284,v285,v286,v287,v288,v289,v290,v291,v292,v293,v294,v295,v296,v297,v298,v299,v300,v301,v302,v303,v304,v305,v306,v307,v308,v309,v310,v311,v312,v313,v314,v315,v316,v317,v318,v319,v320,v321,v322,v323,v324,v325,v326,v327,v328,v329,v330,v331,v332,v333,v334,v335,v336,v337,v338,v339,v340,v341,v342,v343,v344,v345,v346,v347,v348,v349,v350,v351,v352,v353,v354,v355,v356,v357,v358,v359,v360,v361,v362,v363,v364,v365,v366,v367,v368,v369,v370,v371,v372,v373,v374,v375,v376,v377,v378,v379,v380,v381,v382,v383,v384,v385,v386,v387,v388,v389,v390,v391,v392,v393,v394,v395,v396,v397,v398,v399,v400};

char buffer[80];

void setup()			  
{
  Serial.begin(115200);
  Thermal.begin(19200); // to write to our new printer
  pinMode(buttonPin, INPUT);  //Dichiaro il pin 2 come input
  initPrinter();



}


void loop()			  
{
  /* Using the string table in program memory requires the use of special functions to retrieve the data.
   The strcpy_P function copies a string from program space to a string in RAM ("buffer"). 
   Make sure your receiving string in RAM  is large enough to hold whatever
   you are retrieving from program space. */
  buttonState = digitalRead(buttonPin);  //Legge il valore del pulsante, ossia il valore del pin 2
  //Controllo lo stato del pulsante
  if (buttonState == HIGH)
    generaPoesia();  //Spengo il led


}


void initPrinter()
{
  //Modify the print speed and heat
  Thermal.write(27);
  Thermal.write(55);
  Thermal.write(7); //Default 64 dots = 8*('7'+1)
  Thermal.write(heatTime); //Default 80 or 800us
  Thermal.write(heatInterval); //Default 2 or 20us
  //Modify the print density and timeout
  Thermal.write(18);
  Thermal.write(35);
  int printSetting = (printDensity<<4) | printBreakTime;
  Thermal.write(printSetting); //Combination of printDensity and printBreakTime
  Serial.println();
  Serial.println("Printer ready"); 
}


void generaPoesia(){
  randomSeed(analogRead(0));
  int nVersi=int(random(10,16));
  Serial.print("Numero versi:");
  Serial.println(nVersi);  
  for (int i = 1; i < nVersi; i++)
  {
    int indVerso=int(random(1,V_SIZE));
    strcpy_P(buffer, (char*)pgm_read_word(&(poesia[indVerso]))); // Necessary casts and dereferencing, just copy. 
    Serial.println( buffer );
    if (i==1){
      // underline - two pixels
      Thermal.write(27); 
      Thermal.write(45);
      Thermal.write(2); 

      Thermal.println(buffer);
      Thermal.print(10,BYTE);
      delay(100);

      // turn off underline
      Thermal.write(27); 
      Thermal.write(45);
      Thermal.write(zero);
      Thermal.print(10,BYTE);

    }

    Thermal.println(buffer);
    Thermal.print(10,BYTE);
    delay(100);  
  }
  Thermal.print(10,BYTE);
  Thermal.print(10,BYTE);
  Thermal.print(10,BYTE);
  delay(100);  
  Thermal.println("http://robottini.altervista.org");
  Thermal.print(10,BYTE);
  Thermal.print(10,BYTE);
  Thermal.print(10,BYTE);
  Thermal.print(10,BYTE);
}

